// Package imports:
import 'package:zego_express_engine/zego_express_engine.dart';

enum BeautyEffectType {
  whiten,
  rosy,
  smooth,
  sharpen,
  none,
}

extension BeautyEffectTypeExtension on BeautyEffectType {
  String get text {
    var mapValues = {
      BeautyEffectType.whiten: "Skin Tone",
      BeautyEffectType.rosy: "Blusher",
      BeautyEffectType.smooth: "Smoothing",
      BeautyEffectType.sharpen: "Sharpening",
      BeautyEffectType.none: "None",
    };

    return mapValues[this]!;
  }
}

enum VoiceChangerType {
  none,
  boy,
  lolita,
  empty,
  female,
  male,
  foreigner,
  robot,
  optimus,
  uncle,
  aunt,
  majorC,
  minorA,
  harmonicMinor,
}

extension VoiceChangerTypeExtension on VoiceChangerType {
  String get text {
    var mapValues = {
      VoiceChangerType.none: "None",
      VoiceChangerType.boy: "Boy",
      VoiceChangerType.lolita: "Lolita",
      VoiceChangerType.uncle: "Uncle",
      VoiceChangerType.aunt: "Aunt",
      VoiceChangerType.robot: "Robot",
      VoiceChangerType.empty: "Empty",
      VoiceChangerType.female: "Female",
      VoiceChangerType.male: "Male",
      VoiceChangerType.foreigner: "Foreigner",
      VoiceChangerType.optimus: "Optimus",
      VoiceChangerType.majorC: "MajorC",
      VoiceChangerType.minorA: "MinorA",
      VoiceChangerType.harmonicMinor: "Harmonic Minor",
    };

    return mapValues[this]!;
  }

  ZegoVoiceChangerPreset get key {
    var mapValues = {
      VoiceChangerType.none: ZegoVoiceChangerPreset.None,
      VoiceChangerType.boy: ZegoVoiceChangerPreset.MenToChild,
      VoiceChangerType.lolita: ZegoVoiceChangerPreset.WomenToChild,
      VoiceChangerType.uncle: ZegoVoiceChangerPreset.MaleMagnetic,
      VoiceChangerType.aunt: ZegoVoiceChangerPreset.FemaleFresh,
      VoiceChangerType.robot: ZegoVoiceChangerPreset.Android,
      VoiceChangerType.empty: ZegoVoiceChangerPreset.Ethereal,
      VoiceChangerType.female: ZegoVoiceChangerPreset.MenToWomen,
      VoiceChangerType.male: ZegoVoiceChangerPreset.WomenToMen,
      VoiceChangerType.foreigner: ZegoVoiceChangerPreset.Foreigner,
      VoiceChangerType.optimus: ZegoVoiceChangerPreset.OptimusPrime,
      VoiceChangerType.majorC: ZegoVoiceChangerPreset.MajorC,
      VoiceChangerType.minorA: ZegoVoiceChangerPreset.MinorA,
      VoiceChangerType.harmonicMinor: ZegoVoiceChangerPreset.HarmonicMinor,
    };

    return mapValues[this]!;
  }
}

enum ReverbType {
  none,
  ktv,
  hall,
  concert,
  rock,
  softRoom,
  largeRoom,
  valley,
  recordingStudio,
  basement,
  popular,
  gramophone,
}

extension ReverbTypeExtension on ReverbType {
  String get text {
    var mapValues = {
      ReverbType.none: "None",
      ReverbType.ktv: "KTV",
      ReverbType.hall: "Hall",
      ReverbType.concert: "Concert",
      ReverbType.rock: "Rock",
      ReverbType.softRoom: "Soft Room",
      ReverbType.largeRoom: "Large Room",
      ReverbType.valley: "Valley",
      ReverbType.recordingStudio: "Recording Studio",
      ReverbType.basement: "Basement",
      ReverbType.popular: "Popular",
      ReverbType.gramophone: "Gramophone",
    };

    return mapValues[this]!;
  }

  ZegoReverbPreset get key {
    var mapValues = {
      ReverbType.ktv: ZegoReverbPreset.KTV,
      ReverbType.hall: ZegoReverbPreset.ConcertHall,
      ReverbType.concert: ZegoReverbPreset.VocalConcert,
      ReverbType.rock: ZegoReverbPreset.Rock,
      ReverbType.none: ZegoReverbPreset.None,
      ReverbType.softRoom: ZegoReverbPreset.SoftRoom,
      ReverbType.largeRoom: ZegoReverbPreset.LargeRoom,
      ReverbType.valley: ZegoReverbPreset.Valley,
      ReverbType.recordingStudio: ZegoReverbPreset.RecordingStudio,
      ReverbType.basement: ZegoReverbPreset.Basement,
      ReverbType.popular: ZegoReverbPreset.Popular,
      ReverbType.gramophone: ZegoReverbPreset.GramoPhone,
    };

    return mapValues[this]!;
  }
}
